#include <hmg.ch>

// Compilado con  HMG 3.4.3

PROCEDURE MAIN()

          //Variables para autocompleta
          PUBLIC CgBUCLE:=1
          PUBLIC CgEDIT :=0
          PUBLIC CgNWIN,CgNTEXT,CgNFOCO,CgActTextBox,CgColGrid

          //--------------------------------------------------

          CgActTextBox:="VERDATOS"
          cNEW:=0

          USE CUENTAS
          INDEX ON NOMBRE TO NOMCUENTAS
          INDEX ON CIF TO CIFCUENTAS
          //PACK
          USE


          LOAD WINDOW WIN_1
          CENTER WINDOW WIN_1

          WIN_1.TEXT_2.SETFOCUS
          WIN_1.TEXT_3.ENABLED:=.F.
          WIN_1.BUTTON_3.ENABLED:=.F.
          WIN_1.BUTTON_4.ENABLED:=.F.

          WIN_1.GRID_1.ColumnHEADER(1):="NOMBRE"
          WIN_1.GRID_1.ColumnHEADER(2):="MATRICULA"
          WIN_1.GRID_1.ColumnWIDTH(1) :=300
          WIN_1.GRID_1.ColumnWIDTH(2) :=90

          ACTIVATE WINDOW WIN_1

RETURN

FUNCTION NUEVO

         cNEW :=1
         CgEDIT:=1
         WIN_1.TEXT_3.ENABLED:=.T.
         WIN_1.TEXT_1.VALUE:=""
         WIN_1.TEXT_2.VALUE:=""
         WIN_1.TEXT_3.VALUE:=""
         WIN_1.BUTTON_1.ENABLED:=.F.
         WIN_1.BUTTON_2.ENABLED:=.F.
         WIN_1.BUTTON_3.ENABLED:=.T.
         WIN_1.BUTTON_4.ENABLED:=.T.
         WIN_1.TEXT_1.SETFOCUS
RETURN

FUNCTION MODIFICAR

         cNEW :=0
         CgEDIT:=1
         WIN_1.TEXT_3.ENABLED:=.T.
         WIN_1.BUTTON_1.ENABLED:=.F.
         WIN_1.BUTTON_2.ENABLED:=.F.
         WIN_1.BUTTON_3.ENABLED:=.T.
         WIN_1.BUTTON_4.ENABLED:=.T.

RETURN

FUNCTION GRABAR

         IF cNEW=1
            APPEND BLANK
         ENDIF
         REPLACE NOMBRE WITH WIN_1.TEXT_1.VALUE
         REPLACE CIF WITH WIN_1.TEXT_2.VALUE
         REPLACE TLF WITH WIN_1.TEXT_3.VALUE
         MSGINFO("Cliente creado/modificado","Aviso")
         CANCELAR()
RETURN

FUNCTION CANCELAR

         WIN_1.TEXT_3.ENABLED:=.F.
         WIN_1.BUTTON_1.ENABLED:=.T.
         WIN_1.BUTTON_2.ENABLED:=.T.
         WIN_1.BUTTON_3.ENABLED:=.F.
         WIN_1.BUTTON_4.ENABLED:=.F.
         CgEDIT:=0
RETURN


FUNCTION VERDATOS(CgNDBF,CgNCAMPO)

         IF CgNTEXT<>"Text_1"
            SETPROPERTY(CgNWIN,"TEXT_1","VALUE",&CgNDBF->NOMBRE)
         ENDIF
         IF CgNTEXT<>"Text_2"
            SETPROPERTY(CgNWIN,"TEXT_2","VALUE",&CgNDBF->CIF)
         ENDIF

         SETPROPERTY(CgNWIN,"TEXT_3","VALUE",&CgNDBF->TLF)

         //--------------------------------------

         CgLLENAGRID(CgNDBF,CgNCAMPO,"GRID_1", "{ CUENTAS->NOMBRE, CUENTAS->CIF }")


RETURN NIL



//-------------------------- FUNCION AUTOCOMPLETA ------------------------------
/*
* Funcion que autocompleta, en uno o varios TextBox los campos de base datos.
* Celestino G. (Espaa) 2016
*
* ------------------------------------------------------------------------------
* Crear las siguientes variables publicas en la funcion MAIN:
*
* Public CgBucle:=1
* Public CgEdit :=0
* Public CgNWIN,CgNTEXT,CgNFOCO,CgActTextBox,CgColGrid
*
* ------------------------------------------------------------------------------
* Para permitir la edicion en los TextBox que se autocompletan es necesario
* incluir la variable CgEdit en las funciones correspondientes y asignar el
* valor que se requiera para permitir la edicion o no.
*
* CgEdit:=1   //Valor para editar
* CgEdit:=0   //Valor para autocompletar
*
* ------------------------------------------------------------------------------
* Completar las propiedades y eventos del TextBox de la siguiente forma:
*
*  --------------------------
*  Propiedad:    Valor:
*  --------------------------
*
*  DataType      CHARACTER
*
*  CaseConvert   UPPER
*
*  --------------------------
*  Evento:       Valor:
*  --------------------------
*
*  OnChange      AutoCompleta(<nombre b/datos>,<nombre campo>)
*
*  OnGotFocus    CgCogeFoco(,<nCol Grid>,<nombre b/datos>,<nombre campo>,
*                <indice 1>,<indice 2>,<indice 3>,<indice 4>)
*
*  OnLostFocus   CgDejaFoco()  //Opcional: CgDejaFoco(0) cierra base datos
*
*
* La funcion la he escrito para usar con caracteres en mayusculas. Si se desea
* se puede ampliar o modificar para alternar o enlazar con mayusculas y
* minusculas o tambien para utilizar valores numericos.
* ------------------------------------------------------------------------------
* Para visualizar los datos en los distintos TextBox y Grid crear una funcion
* como la del ejemplo y declarar el nombre de la misma en la variable
* CgActTextBox
*
* Ejemplo:
*
* CgActTextBox:="EjemploFuncion" //Declarar en la ventana activa
*
* FUNCTION EjemploFuncion(CgNDBF,CgNCAMPO)
*
*         //Aqui especificar los TextBox en los que se autocompleta
*
*         If CgNTEXT<>"Text_1" //Especificar la propiedad Name del TextBox
*            SetProperty(CgNWIN,"TEXT_1","VALUE",&CgNDBF->NOMBRE)
*         Endif
*         If CgNTEXT<>"Text_2"
*            SetProperty(CgNWIN,"TEXT_2","VALUE",&CgNDBF->CIF)
*         Endif
*         If CgNTEXT<>"Text_3"
*            SetProperty(CgNWIN,"TEXT_3","VALUE",&CgNDBF->CODICLI)
*         Endif
*         If ............
*            .........
*         Endif
*
*         //Aqui especificar los TextBox que se quieran mostrar
*
*         SetProperty(CgNWIN,"TEXT_4","VALUE",&CgNDBF->TLF)
*         SetProperty(CgNWIN,"TEXT_5","VALUE",&CgNDBF->DIRECCION)
*         SetProperty .......
*         SetProperty .........
*
*         //Si quieren incluir GRID aadir la siguiente linea
*
*         CgLLENAGRID(CgNDBF,CgNCAMPO,"GRID_1", "{ CUENTAS->NOMBRE, CUENTAS->CIF }")
*         .......
*         ....
*
* RETURN Nil
*
*/
//------------------------------------------------------------------------------

/***********************************************************************/
 FUNCTION AUTOCOMPLETA(CgNDBF,CgNCAMPO)
/***********************************************************************/
          CgXNON:= THIS.NAME

          IF CgEDIT = 0
             IF CgNFOCO == CgXNON
                CgINIAUTOCOM(CgNDBF,CgNCAMPO)
             ENDIF
          ENDIF

 RETURN NIL

/***********************************************************************/
 FUNCTION CgINIAUTOCOM(CgNDBF,CgNCAMPO)
/***********************************************************************/

          CgNWIN := THISWINDOW.NAME
          CgNTEXT:= THIS.NAME

          IF CgBUCLE = 1

             CgPCURSOR:= GETPROPERTY(CgNWIN,CgNTEXT,"CARETPOS")

             CgBUSCA  := LEFT(UPPER(ALLTRIM(GETPROPERTY(CgNWIN,CgNTEXT,"VALUE"))),CgPCURSOR)

             ON KEY UP OF &CgNWIN ACTION CgATRAS(CgNDBF,CgNCAMPO,CgNWIN,CgNTEXT)
             ON KEY DOWN OF &CgNWIN ACTION CgDELANTE(CgNDBF,CgNCAMPO,CgNWIN,CgNTEXT)

             DBSELECTAREA(CgNDBF)
             CgACTU:= &CgNCAMPO
             CgPOS := RECNO()
             DBSEEK(CgBUSCA)

             CgBUCLE:= 0

             IF FOUND()
                SETPROPERTY(CgNWIN,CgNTEXT,"VALUE",&CgNDBF->&CgNCAMPO)
                SETPROPERTY(CgNWIN,CgNTEXT,"CARETPOS",CgPCURSOR)
                CgACTUALIZA_TEXTBOX(CgNDBF,CgNCAMPO)
             ELSE
                SETPROPERTY(CgNWIN,CgNTEXT,"VALUE",CgACTU)
                SETPROPERTY(CgNWIN,CgNTEXT,"CARETPOS",CgPCURSOR-1)
                GOTO CgPOS
             ENDIF

          ELSE

             CgBUCLE:= 1

          ENDIF

 RETURN NIL

/***********************************************************************/
 FUNCTION CgACTUALIZA_TEXTBOX(CgNDBF,CgNCAMPO)
/***********************************************************************/

          IF !EMPTY (CgActTextBox)
             &CgActTextBox(CgNDBF,CgNCAMPO)
          ENDIF
 RETURN NIL

/***********************************************************************/
 FUNCTION CgCOGEFOCO(vCgColGrid,CgNDBF,CgNCAMPO,CgINDEX1,CgINDEX2,CgINDEX3,CgINDEX4)
/***********************************************************************/

          CgColGrid:= vCgColGrid

          CgNFOCO  := THIS.NAME
          CgNWIN   := THISWINDOW.NAME

          SETPROPERTY(CgNWIN,CgNFOCO,"CARETPOS",0)

          IF CgEDIT = 0
             CLOSE &CgNDBF
             USE &CgNDBF INDEX &CgINDEX1,&CgINDEX2,&CgINDEX3,&CgINDEX4 //SHARED NEW
             AUTOCOMPLETA(CgNDBF,CgNCAMPO)
          ENDIF

 RETURN NIL

/***********************************************************************/
 FUNCTION CgDEJAFOCO(CgCierraBd)
/***********************************************************************/

          CgNWIN:= THISWINDOW.NAME

          RELEASE KEY UP OF &CgNWIN
          RELEASE KEY DOWN OF &CgNWIN

          IF CgCierraBd = 0
             CLOSE &CgNDBF
          ENDIF

 RETURN NIL


/***********************************************************************/
 FUNCTION CgATRAS(CgNDBF,CgNCAMPO,CgNWIN,CgTEXT)
/***********************************************************************/

          CgBUCLE  := 0
          CgPCURSOR:= GETPROPERTY(CgNWIN,CgNTEXT,"CARETPOS")
          SKIP -1
          SETPROPERTY(CgNWIN,CgNTEXT,"VALUE",&CgNDBF->&CgNCAMPO)
          SETPROPERTY(CgNWIN,CgNTEXT,"CARETPOS",CgPCURSOR)
          CgACTUALIZA_TEXTBOX(CgNDBF,CgNCAMPO)

 RETURN NIL

/***********************************************************************/
 FUNCTION CgDELANTE(CgNDBF,CgNCAMPO,CgNWIN,CgNTEXT)
/***********************************************************************/

          CgBUCLE  := 0
          CgPCURSOR:= GETPROPERTY(CgNWIN,CgNTEXT,"CARETPOS")
          SKIP
          IF EOF()
             SKIP -1
          ENDIF
          SETPROPERTY(CgNWIN,CgNTEXT,"VALUE",&CgNDBF->&CgNCAMPO)
          SETPROPERTY(CgNWIN,CgNTEXT,"CARETPOS",CgPCURSOR)
          CgACTUALIZA_TEXTBOX(CgNDBF,CgNCAMPO)

 RETURN NIL


/***********************************************************************/
 FUNCTION CgLLENAGRID(CgNDBF,CgNCAMPO,CgNGRID,CgCAMPOS)
/***********************************************************************/

          CgXPOS   := RecNo()

          CgMCURSOR:= GETPROPERTY(CgNWIN,CgNTEXT,"CARETPOS")
          CgBUS    := SUBSTR(UPPER(ALLTRIM(GetProperty(CgNWIN,CgNTEXT,"VALUE"))),1,CgMCURSOR)
          CgCANT   := CgMCURSOR
          CgMAXREG := 0

          IF CgMCURSOR = 0
             CgCANT:= 1
             CgBUS := SUBSTR(UPPER(ALLTRIM(GetProperty(CgNWIN,CgNTEXT,"VALUE"))),1,1)
          ENDIF

          GO TOP
          DBSEEK(CgBUS)

          DELETE ITEM ALL FROM &CgNGRID OF &CgNWIN

          DO WHILE !EOF()
             IF SUBSTR(FIELD->&CgNCAMPO,1,CgCANT) == CgBUS
                CgMAXREG += 1
                IF CgMAXREG > 50
                   EXIT
                ENDIF
                ADD ITEM &CgCAMPOS TO &CgNGRID OF &CgNWIN
             ENDIF
             DBSKIP()
          ENDDO

          GO CgXPOS

 RETURN NIL


 FUNCTION CgCLIPITEM()

          CgEDIT  := 1

          CgNGRID := THIS.NAME
          CgNLINEA:= GETPROPERTY(CgNWIN,CgNGRID,"VALUE")                       
          CgNEWTEX:= GETPROPERTY(CgNWIN,CgNGRID,"CELLEX",CgNLINEA,CgColGrid)   

          SETPROPERTY(CgNWIN,CgNTEXT,"VALUE",CgNEWTEX)

          CgEDIT  := 0

 RETURN NIL


